import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import { s as styleInject } from './index-84f8b9f7.js';
import { useState, useEffect } from 'react';
import { useDivaCore, useTranslation } from '@crystaldesign/diva-core';
import QRCode from 'react-qr-code';
import { jsxs, Fragment, jsx } from 'react/jsx-runtime';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/toConsumableArray';
import 'classnames';
import '@babel/runtime/helpers/objectWithoutProperties';
import 'react-dom/server';
import 'swiper/react';
import 'swiper/modules';

var arMessage = "ar-message-zKBdY";
var qrCode = "qr-code-TQTqE";
var closingIcon = "closing-icon-XDdcy";
var textBox = "text-box-rZjH8";
var css_248z = ".ar-message-zKBdY {\n  position: absolute;\n  bottom: 10px;\n  right: 0px;\n  left: 0px;\n  margin-left: auto;\n  margin-right: auto;\n  width: 361px;\n  height: 90px;\n  margin-bottom: 10px;\n  display: flex;\n  flex-direction: row;\n  gap: 10px;\n  box-shadow: rgba(0, 0, 0, 0.1) 0px 0px 0.75rem 0.15rem;\n  border-radius: 0.3rem;\n  padding-left: 5px;\n  padding-right: 5px;\n  align-items: center;\n  gap: 10px;\n}\n\n.qr-code-TQTqE {\n  width: 80px;\n  height: 80px;\n}\n\n.closing-icon-XDdcy {\n  position: absolute;\n  cursor: pointer;\n  top: 7px;\n  right: 7px;\n  width: 12px;\n  height: 12px;\n  background-image: url(\"data:image/svg+xml,%3Csvg width%3D%228%22 height%3D%228%22 viewBox%3D%220 0 8 8%22 fill%3D%22none%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%3E%3Cpath d%3D%22M6.99998 1.13477L1 7.13475M6.99998 7.13477L1 1.13479%22 stroke%3D%22%23B6B6B7%22 stroke-width%3D%221.5%22 stroke-linecap%3D%22round%22%2F%3E%3C%2Fsvg%3E\");\n  background-repeat: no-repeat;\n  z-index: 1;\n}\n\n.text-box-rZjH8 {\n  width: 250px;\n  height: 80px;\n  word-wrap: break-word;\n  font-family: var(--diva-typography-font-family);\n}\n";
styleInject(css_248z);

var ArViewer = function ArViewer(_ref) {
  var _arViewerSettings$arV, _arViewerSettings$arV2, _arViewerSettings$arV3, _arViewerSettings$arV4;
  var url = _ref.url,
    qrCodeUrl = _ref.qrCodeUrl,
    cameraArButton = _ref.cameraArButton,
    viewerClassName = _ref.viewerClassName,
    arViewerSettings = _ref.arViewerSettings,
    isCurrentlyVisible = _ref.isCurrentlyVisible;
  var arModes = '';
  var _useDivaCore = useDivaCore(),
    actions = _useDivaCore.actions,
    _useDivaCore$state = _useDivaCore.state,
    isFirefox = _useDivaCore$state.isFirefox,
    isMobile = _useDivaCore$state.isMobile;
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    arViewerSettingsIdx = _useState2[0],
    setArViewerSettingsIdx = _useState2[1];
  var _useState3 = useState(!isMobile),
    _useState4 = _slicedToArray(_useState3, 2),
    showQrCode = _useState4[0],
    setShowQrCode = _useState4[1];
  useEffect(function () {
    actions.loadModelViewer();
  }, []);
  if (cameraArButton) {
    arModes += 'scene-viewer quick-look';
  }
  function onArViewerSettingsChanged(e) {
    setArViewerSettingsIdx(parseInt(e.target.value));
  }
  return /*#__PURE__*/jsxs(Fragment, {
    children: [showQrCode && isCurrentlyVisible !== false && qrCodeUrl && /*#__PURE__*/jsxs("div", {
      className: arMessage,
      children: [/*#__PURE__*/jsx(QRCode, {
        value: qrCodeUrl,
        className: qrCode
      }), /*#__PURE__*/jsx("div", {
        className: textBox,
        children: t('pdp.ar.qrtext')
      }), /*#__PURE__*/jsx("div", {
        className: closingIcon,
        id: "arThumbnailImg",
        onClick: function onClick() {
          return setShowQrCode(false);
        }
      })]
    }), /*#__PURE__*/jsx("model-viewer", {
      src: url,
      alt: "A AR Model of a Chair",
      "environment-image": (arViewerSettings === null || arViewerSettings === void 0 ? void 0 : arViewerSettings[arViewerSettingsIdx].environmentImage) === 'default' ? undefined : 'neutral',
      shadowIntensity: (_arViewerSettings$arV = arViewerSettings === null || arViewerSettings === void 0 ? void 0 : arViewerSettings[arViewerSettingsIdx].shadowIntensity) !== null && _arViewerSettings$arV !== void 0 ? _arViewerSettings$arV : 1,
      shadowSoftness: (_arViewerSettings$arV2 = arViewerSettings === null || arViewerSettings === void 0 ? void 0 : arViewerSettings[arViewerSettingsIdx].shadowSoftness) !== null && _arViewerSettings$arV2 !== void 0 ? _arViewerSettings$arV2 : 1,
      exposure: (_arViewerSettings$arV3 = arViewerSettings === null || arViewerSettings === void 0 ? void 0 : arViewerSettings[arViewerSettingsIdx].exposure) !== null && _arViewerSettings$arV3 !== void 0 ? _arViewerSettings$arV3 : 1,
      useEnvironmentasSkybox: (_arViewerSettings$arV4 = arViewerSettings === null || arViewerSettings === void 0 ? void 0 : arViewerSettings[arViewerSettingsIdx].useEnvironmentasSkybox) !== null && _arViewerSettings$arV4 !== void 0 ? _arViewerSettings$arV4 : false,
      "camera-controls": true,
      ar: true,
      "ar-modes": !isFirefox ? arModes : '',
      style: {
        overscrollBehavior: 'none',
        width: '100%',
        height: '100%',
        touchAction: 'none'
      },
      "class": viewerClassName
    }), arViewerSettings && /*#__PURE__*/jsx("select", {
      name: "arViewerSetting",
      id: "arViewerSettings",
      style: {
        position: 'absolute',
        top: '0px'
      },
      onChange: function onChange(e) {
        return onArViewerSettingsChanged(e);
      },
      children: arViewerSettings.map(function (arViewerSetting, idx) {
        return /*#__PURE__*/jsx("option", {
          value: idx,
          children: arViewerSetting.name
        }, idx);
      })
    })]
  });
};

export { ArViewer as default };
