import _asyncToGenerator from '@babel/runtime/helpers/asyncToGenerator';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _regeneratorRuntime from '@babel/runtime/regenerator';
import { s as styleInject } from './index-84f8b9f7.js';
import { getLogger, useTranslation, useDivaCore } from '@crystaldesign/diva-core';
import React, { useMemo, useState, useEffect } from 'react';
import classNames from 'classnames';
import ArViewer from './index-369aa8b1.js';
import { jsx, jsxs, Fragment } from 'react/jsx-runtime';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/toConsumableArray';
import '@babel/runtime/helpers/objectWithoutProperties';
import 'react-dom/server';
import 'swiper/react';
import 'swiper/modules';
import 'react-qr-code';

var hideCloseFullscreen = "hide-close-fullscreen-LcRPK";
var arIcon = "ar-icon-rYTkh";
var rotationIcon = "rotation-icon-DvHEW";
var css_248z = ".diva-media-viewer .smv-button-fullscreen-open .smv-icon {\n  -webkit-mask-image: url(\"data:image/svg+xml,%3Csvg width%3D%2218%22 height%3D%2218%22 viewBox%3D%220 0 18 18%22 fill%3D%22none%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%3E%3Cpath d%3D%22M17 7.00002L17 1.00004L11 1.00004M0.999963 11L0.999963 17L6.99998 17%22 stroke%3D%22%234F4F4F%22 stroke-width%3D%221.5%22 stroke-linecap%3D%22round%22 stroke-linejoin%3D%22round%22%2F%3E%3C%2Fsvg%3E\") !important;\n  mask-image: url(\"data:image/svg+xml,%3Csvg width%3D%2218%22 height%3D%2218%22 viewBox%3D%220 0 18 18%22 fill%3D%22none%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%3E%3Cpath d%3D%22M17 7.00002L17 1.00004L11 1.00004M0.999963 11L0.999963 17L6.99998 17%22 stroke%3D%22%234F4F4F%22 stroke-width%3D%221.5%22 stroke-linecap%3D%22round%22 stroke-linejoin%3D%22round%22%2F%3E%3C%2Fsvg%3E\") !important;\n  mask-size: 75% !important;\n  -webkit-mask-size: 75% !important;\n}\n\n.diva-media-viewer .smv-button-fullscreen-open .smv-icon {\n  -webkit-mask-repeat: no-repeat;\n          mask-repeat: no-repeat;\n  background-color: #4f4f4f;\n}\n\n.hide-close-fullscreen-LcRPK .smv-button .smv-button-fullscreen .smv-button-fullscreen-close {\n  display: none;\n}\n\n.diva-media-viewer .smv-bullets.smv-h .smv-selectors {\n  min-height: 20px !important;\n}\n\n.smv-thumbnails .smv-selector[data-type='spin']:before {\n  background-image: url('https://scripts.sirv.com/sirvjs/v3/graphics/icons/white/icon.spin.12.svg') !important;\n}\n\n.diva-product-wrapper .smv-selectors-box.smv-v.smv-thumbnails {\n  margin: 10px;\n  height: calc(100% - 20px);\n}\n\n#DivaCore .smv-selectors-box {\n  z-index: 50;\n}\n\n#DivaCore .smv-selectors-scroll-container .smv-scroll {\n  align-items: inherit;\n}\n.ar-icon-rYTkh {\n  height: 100%;\n  width: 100%;\n  background-size: contain;\n  background-position: center;\n  width: 70px;\n  height: 70px;\n  background-image: url(\"data:image/svg+xml,%3Csvg version%3D%221.0%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22 width%3D%22250.000000pt%22 height%3D%22250.000000pt%22 viewBox%3D%220 0 250.000000 250.000000%22 preserveAspectRatio%3D%22xMidYMid meet%22%3E  %3Cg transform%3D%22translate(0.000000%2C250.000000) scale(0.100000%2C-0.100000)%22  fill%3D%22%23000000%22 stroke%3D%22none%22%3E  %3Cpath d%3D%22M642 2047 l-32 -33 0 -765 0 -765 33 -32 33 -32 385 0 385 0 32 33  32 33 0 765 0 765 -33 32 -33 32 -385 0 -385 0 -32 -33z m136 -64 c6 -57 11  -58 282 -58 274 0 280 1 280 62 0 34 1 34 33 28 17 -4 38 -13 46 -20 26 -25  32 -202 29 -833 l-3 -634 -24 -19 c-22 -18 -43 -19 -361 -19 -318 0 -339 1  -361 19 l-24 19 -3 694 c-2 381 0 708 3 726 4 23 16 39 38 53 43 26 61 21 65  -18z%22%2F%3E  %3Cpath d%3D%22M1153 1629 l-213 -121 0 -321 0 -322 97 -55 c255 -145 337 -189 345  -184 4 3 8 19 8 35 0 33 -5 37 -245 182 l-120 72 -3 248 c-1 136 0 247 2 247  2 0 74 -40 159 -90 86 -49 166 -91 179 -92 20 -3 23 1 23 31 0 33 -3 36 -157  125 -87 50 -158 94 -158 98 0 3 64 44 142 89 78 46 150 91 160 101 21 21 25  78 6 78 -7 0 -109 -55 -225 -121z%22%2F%3E  %3Cpath d%3D%22M1580 1726 c0 -21 7 -43 18 -54 10 -10 83 -56 163 -102 79 -45 145  -84 147 -85 2 -1 -61 -40 -140 -85 -165 -95 -188 -114 -188 -150 0 -52 -4 -54  218 76 79 46 145 84 148 84 2 0 3 -111 2 -247 l-3 -248 -120 -72 c-240 -145  -245 -149 -245 -182 0 -16 4 -32 8 -35 8 -5 87 37 345 184 l97 55 -2 323 -3  324 -160 90 c-88 49 -188 106 -222 125 l-63 35 0 -36z%22%2F%3E  %3C%2Fg%3E%3C%2Fsvg%3E\");\n}\n\n.rotation-icon-DvHEW {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 30px;\n  height: 30px;\n  background: center / contain no-repeat url(\"data:image/svg+xml,%3Csvg width%3D%2220%22 height%3D%2220%22 viewBox%3D%220 0 20 20%22 fill%3D%22none%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%3E%3Crect x%3D%2219%22 y%3D%229%22 width%3D%2210%22 height%3D%2215%22 rx%3D%223%22 transform%3D%22rotate(90 19 9)%22 stroke%3D%22%234F4F4F%22 stroke-width%3D%221.2%22%2F%3E%3Cpath d%3D%22M1 17.0009L1 4.00085C1 2.344 2.34315 1.00085 4 1.00085L8 1.00085C9.65685 1.00085 11 2.344 11 4.00085L11 9.00085%22 stroke%3D%22%234F4F4F%22 stroke-width%3D%221.2%22 stroke-linecap%3D%22round%22%2F%3E%3Cpath d%3D%22M17 6.00085C17 3.79172 15.2091 2.00085 13 2.00085%22 stroke%3D%22%234F4F4F%22 stroke-linecap%3D%22round%22%2F%3E%3Cpath d%3D%22M15 5.00084L17 6.94617L19 5.00082%22 stroke%3D%22%234F4F4F%22 stroke-linecap%3D%22round%22 stroke-linejoin%3D%22round%22%2F%3E%3C%2Fsvg%3E\");\n  z-index: 100;\n  margin: 16px;\n}\n\n#DivaCore .smv-item smv-thumbnail[data-type='html'] {\n  width: auto !important;\n  height: auto !important;\n}\n";
styleInject(css_248z);

var MediaViewer = function MediaViewer(_ref) {
  var mediasData = _ref.medias,
    mediaIds = _ref.mediaIds,
    _ref$itemKey = _ref.itemKey,
    itemKey = _ref$itemKey === void 0 ? 'MediaViewer' : _ref$itemKey,
    onLandscapeOptions = _ref.onLandscapeOptions,
    defaultDataOptions = _ref.defaultDataOptions,
    _ref$currentItem = _ref.currentItem,
    currentItem = _ref$currentItem === void 0 ? 0 : _ref$currentItem,
    showRotationIconInFullscreen = _ref.showRotationIconInFullscreen,
    setCurrentItem = _ref.setCurrentItem,
    keepOldZoomIcons = _ref.keepOldZoomIcons;
  //LOG cannot be loaded globally because it will cause a circular dependency with core
  useMemo(function () {
    return getLogger('MediaViewer', 'ContentBox');
  }, []);
  var _useState = useState(mediasData),
    _useState2 = _slicedToArray(_useState, 2),
    medias = _useState2[0],
    setMedias = _useState2[1];
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var id = itemKey;
  var _useDivaCore = useDivaCore(),
    _useDivaCore$state = _useDivaCore.state,
    _useDivaCore$state$di = _useDivaCore$state.dimensions,
    isPortrait = _useDivaCore$state$di.isPortrait,
    isMobile = _useDivaCore$state$di.isMobile,
    isTablet = _useDivaCore$state$di.isTablet,
    height = _useDivaCore$state$di.height,
    width = _useDivaCore$state$di.width,
    _useDivaCore$state$ap = _useDivaCore$state.apiConfig,
    baseSirvUrls = _useDivaCore$state$ap.baseSirvUrls,
    arViewerBaseUrl = _useDivaCore$state$ap.arViewerBaseUrl,
    mediaHandler = _useDivaCore.handler.mediaHandler;
  useEffect(function () {
    setMedias(mediasData);
  }, [mediasData]);
  useEffect(function () {
    if (!keepOldZoomIcons) import('./zoom.module-e7f652df.js');
  }, []);
  useEffect(function () {
    var _medias$map;
    if (!(mediaIds !== null && mediaIds !== void 0 && mediaIds.length) || JSON.stringify(mediaIds) === JSON.stringify((_medias$map = medias === null || medias === void 0 ? void 0 : medias.map(function (media) {
      return media._id;
    })) !== null && _medias$map !== void 0 ? _medias$map : [])) return;
    mediaHandler.getMediaByIds(mediaIds).then(function (medias) {
      setMedias(medias);
    });
  }, [mediaIds]);

  /**Subscribe on events of the media viewer */

  var fullscreenIn = function fullscreenIn() {
    if (showRotationIconInFullscreen && isMobile && isPortrait && width < 500) {
      var fullscreenContainer = document.getElementsByClassName('smv-fullscreen-box')[0];
      if (fullscreenContainer) {
        var div = document.createElement('div');
        div.className = rotationIcon;
        fullscreenContainer.appendChild(div);
      }
    }
  };
  var onSpinReady = function onSpinReady(e) {
    setCurrentItem === null || setCurrentItem === void 0 || setCurrentItem(e.index);
  };
  var subscribeToEvents = function subscribeToEvents() {
    var sirv = window.Sirv;
    sirv.on('viewer:afterSlideIn', onSpinReady);
    sirv.on('viewer:fullscreenIn', fullscreenIn);
  };
  useEffect(function () {
    var wind = window;
    if (!wind.Sirv) {
      loadSirv('zoom, spin, video', medias).then(function () {
        subscribeToEvents();
        wind.Sirv.start();
      });
    } else {
      subscribeToEvents();
    }
    return function () {
      var sirv = wind.Sirv;
      if (!sirv) return;
      sirv.off('viewer:afterSlideIn', onSpinReady);
      sirv.off('viewer:fullscreenIn', fullscreenIn);
    };
  }, []);
  var dataOptions = defaultDataOptions;
  if (currentItem !== undefined) {
    dataOptions += ';slide.first:' + currentItem;
  }
  if (!isPortrait && isMobile && onLandscapeOptions && height < 500) {
    dataOptions += onLandscapeOptions;
  }
  if (t('sirv.zoom.hint.text.click', '')) dataOptions += ";zoom.hint.text.click: ".concat(t('sirv.zoom.hint.text.click'));
  if (t('sirv.zoom.hint.text.hover', '')) dataOptions += ";zoom.hint.text.hover: ".concat(t('sirv.zoom.hint.text.hover'));
  if (t('sirv.zoom.hint.text.dblclick', '')) dataOptions += ";zoom.hint.text.dblclick: ".concat(t('sirv.zoom.hint.text.dblclick'));
  if (t('sirv.spin.hint.message.text', '')) dataOptions += ";zoom.spin.hint.message.text: ".concat(t('sirv.spin.hint.message.text'));
  return /*#__PURE__*/jsx("div", {
    id: id,
    className: classNames(hideCloseFullscreen, 'Sirv basic 3DSirvViewer-Container', 'diva-media-viewer'),
    "data-options": dataOptions,
    children: medias === null || medias === void 0 ? void 0 : medias.map(function (item, index) {
      return getMediaItem(item, index, currentItem, isMobile && !isTablet, baseSirvUrls, arViewerBaseUrl);
    })
  }, id);
};

/****************************Helper functions ****************************************/

var loadSirv = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee(components, medias) {
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          return _context.abrupt("return", new Promise(function (resolve) {
            var script = document.createElement('script');
            script.src = 'https://scripts.sirv.com/sirvjs/v3/sirv.js';
            script.type = 'text/javascript';
            script.async = true;
            script.dataset.components = components;
            script.onload = resolve;
            document.body.appendChild(script);
          }));
        case 1:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function loadSirv(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();
var getMediaItem = function getMediaItem(item, index, currentItemIndex, isMobile) {
  var _item$shortUrl;
  var baseSirvUrls = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : [];
  var arViewerUrl = arguments.length > 5 ? arguments[5] : undefined;
  var isSirvItem = !!baseSirvUrls.find(function (base) {
    return item.url.includes(base);
  });
  var thumb = getThumb(item);
  switch (item.mediaType) {
    case 'SPIN':
    case 'SPN':
    case 'VID':
    case 'PCT':
    case undefined:
      try {
        var url = new URL(item.url);
        if (isMobile && !['SPIN', 'SPN'].includes(item.mediaType)) {
          url.searchParams.append('scale.option', 'noup');
          url.searchParams.append('w', '3000');
        }
        if (isSirvItem) {
          url.searchParams.append('crop.type', 'trim');
          url.searchParams.append('crop.pad.x', '10%');
          url.searchParams.append('crop.pad.y', '10%');
        } else {
          return /*#__PURE__*/jsx("img", {
            "data-src": url.toString(),
            "data-type": "static",
            "data-option": "fit:cover",
            id: "main3dImage",
            children: thumb
          }, url.toString());
        }
        return /*#__PURE__*/jsx("div", {
          "data-src": url.toString(),
          id: 'main3dImage',
          "data-options": item.functionType == 'SHO' || item.functionType == 'ART' ? 'mode:deep' : undefined,
          "data-type": item.mediaType == 'PCT' ? 'zoom' : undefined,
          children: thumb
        }, url.toString());
      } catch (_unused) {
        return /*#__PURE__*/jsx("div", {
          children: "Invalid Url"
        });
      }
    case 'AR':
      return /*#__PURE__*/jsxs("div", {
        "data-swipe-disabled": true,
        children: [/*#__PURE__*/jsx(ArViewer, {
          url: item.url,
          arViewerSettings: item.arViewerSettings,
          qrCodeUrl: arViewerUrl ? arViewerUrl + '/arViewer?arMedia=' + ((_item$shortUrl = item.shortUrl) !== null && _item$shortUrl !== void 0 ? _item$shortUrl : item.url) : undefined,
          type: 'ArViewer',
          cameraArButton: true,
          isCurrentlyVisible: currentItemIndex === index
        }), thumb]
      }, index);
  }
  return /*#__PURE__*/jsx(Fragment, {});
};
var getThumb = function getThumb(media) {
  var thumb = media.thumb;
  if (typeof thumb === 'string') {
    return thumb = /*#__PURE__*/jsx("smv-thumbnail", {
      children: /*#__PURE__*/jsx("img", {
        src: thumb
      }, thumb)
    });
  } else if (/*#__PURE__*/React.isValidElement(thumb)) {
    return thumb = /*#__PURE__*/jsx("smv-thumbnail", {
      children: thumb
    });
  } else if (media.mediaType === 'AR') {
    return /*#__PURE__*/jsx("smv-thumbnail", {
      id: "thumbnail",
      children: /*#__PURE__*/jsx("div", {
        className: arIcon
      })
    });
  }
  return undefined;
};

export { MediaViewer as default };
